#version 430 core

layout (location=0) out vec4 fragJFAin;
layout (location=1) out vec4 fragPositionVS;
layout (location=2) out vec4 fragNormalVS;

in GeoOut {
	vec3 positionVS;
	vec3 normalVS;
	float paramU;
	float paramQ;
	float isContour;
} fs_in;

uniform bool contour_lines_only = false;

void main() {

	// RGBA layout: x,y: screen frag coord if contour, (-1,-1) if not; .z is screen z coord of pixel; TODO: .w background flag?
	if (fs_in.isContour > 0.5) {
		fragJFAin = vec4(floor(gl_FragCoord.xy), gl_FragCoord.z, 1);
	} else {
		fragJFAin = vec4(-1, -1, gl_FragCoord.z, 0);
	}

	fragPositionVS = vec4(fs_in.positionVS, fs_in.paramQ);
	fragNormalVS   = vec4(fs_in.normalVS,   fs_in.paramU);

}
