#version 430 core

layout (location = 0) in vec3 aPos;
layout (location = 1) in vec3 aNormal;
layout (location = 2) in vec2 aUV;

out VertexData {
	vec3 positionVS;
	vec3 normalVS;
	vec2 UV;
} vs_out;

uniform mat4 matMV;
uniform mat3 matNormalMV;

void main() {
	vs_out.positionVS = vec3(matMV * vec4(aPos, 1.0));
	//vs_out.normalVS = normalize(matNormalMV * aNormal);
	//vs_out.normalVS = normalize(transpose(inverse(matMV)) * vec4(aNormal,0)).xyz; // FIXME - this was just for testing (NOT same result) - messes up contours???? // TODO!!
	vs_out.normalVS = normalize(mat3(transpose(inverse(matMV))) * aNormal); // this is ok, same result as with matNormalMV
	vs_out.UV = aUV;
}
